//#include <stm32f4xx_gpio.h>
//#include <stm32f4xx_rcc.h>
//#include <stm32f4xx_usart.h>
//#include <stm32f4xx_spi.h>
//#include <stm32f4xx_tim.h>
//#include <stm32f4xx_dma.h>
//#include <stm32f4xx_exti.h>
//#include <stm32f4xx_pwr.h>
//#include <misc.h>
#include <stdio.h>
//#include <core_cm4.h>
#include "diskio.h"
#include "ff.h"

#include "stm32f4_discovery.h"
#include "usbd_hid_core.h"
#include "usbd_usr.h"
#include "usbd_desc.h"

/** @addtogroup STM32F4-Discovery_Demo
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

//#define TESTRESULT_ADDRESS         0x080FFFFC
//#define ALLTEST_PASS               0x00000000
//#define ALLTEST_FAIL               0x55555555

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
#ifdef USB_OTG_HS_INTERNAL_DMA_ENABLED
  #if defined ( __ICCARM__ ) /*!< IAR Compiler */
    #pragma data_alignment = 4
  #endif
#endif /* USB_OTG_HS_INTERNAL_DMA_ENABLED */
__ALIGN_BEGIN USB_OTG_CORE_HANDLE  USB_OTG_dev __ALIGN_END;

//uint16_t PrescalerValue = 0;


void Delay(__IO uint32_t nTime);

volatile __IO uint32_t TimingDelay;
volatile __IO uint32_t UserTimingDelay=0;

/* Private function prototypes -----------------------------------------------*/
static uint32_t USBConfig(void);
//extern __IO int8_t X_Offset, Y_Offset, Z_Offset;
//extern uint8_t Buffer[6];

GPIO_InitTypeDef  GPIO_InitStructure;
SPI_InitTypeDef  SPI_InitStructure;

uint8_t RxData[256]; //  
uint8_t TxData[256]; //   
volatile uint8_t RxIn = 0;
volatile uint8_t RxOut = 0;
volatile uint8_t TxIn = 0;
volatile uint8_t TxOut = 0;
//uint8_t RxEmpty=1;
uint32_t cnt=0;

void UsartTx(){
	if(TxIn != TxOut){
		uint8_t tmp=TxData[TxOut++];
		USART_SendData(USART3, tmp);
	}
}
void UsartSend(){
	//if((USART3->SR & USART_SR_TXE) && (TxIn != TxOut)){
	if((USART_GetFlagStatus(USART3,USART_FLAG_TXE)!= RESET) && (TxIn != TxOut)){
		UsartTx();
	}
}
void UsartRx(){
	int tmp=RxIn-RxOut;
	if(tmp<256 && tmp!=-1){
		RxData[RxIn++]=USART_ReceiveData(USART3);
	}
}
uint8_t UsartTestData(){
	return RxIn!=RxOut;
}
uint8_t UsartGetData(){
	return RxData[RxOut++];
}
char UsartPutData(char Dt){
	int tmp=TxIn-TxOut;
	if(tmp<255 && tmp!=-1){
		TxData[TxIn++]=Dt;
		return 1;
	}
	return 0;
}

char path[256];

void initAll()
{
    //  
    __enable_irq();

    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    /* Enable GPIO clock */
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

    /* Enable UART clock */
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

    /* Connect PXx to USARTx_Tx*/
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_USART3);

    /* Connect PXx to USARTx_Rx*/
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource11, GPIO_AF_USART3);

    /* Configure USART Tx as alternate function  */
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    /* Configure USART Rx as alternate function  */
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = 38400;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

    /* USART configuration */
    USART_Init(USART3, &USART_InitStructure);

    /* Enable USART */
    NVIC_EnableIRQ(USART3_IRQn);
    USART_Cmd(USART3, ENABLE);

   //     USART


    USART_ITConfig(USART3, USART_IT_TC, ENABLE);
    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);

}


/*void SysTick_Handler(void)
{
	volatile static uint8_t cntdiskio=0;
	cntdiskio++;
	if ( cntdiskio >= 10 ) {
		cntdiskio = 0;
		disk_timerproc(); // to be called every 10ms
		//UsartSend();
	}

}*/

FRESULT scan_files (
    char* path  /*   
 (    ) */)
{
    FRESULT res;
    FILINFO fno;
    DIR dir;
    int i;
    char *fn; // ,    Unicode.
#if _USE_LFN
    static char lfn[_MAX_LFN + 1];
    fno.lfname = lfn;
    fno.lfsize = sizeof(lfn);
#endif
    res = f_opendir(&dir, path); //  
    if (res == FR_OK)
    {
    	//printf("Opened dir %s\n\r",path);
        i = strlen(path);
    	//i=0;
        for (;;)
        {
        //	printf(" -%d- ",i);
            res = f_readdir(&dir, &fno);  //   
            if (res != FR_OK || fno.fname[0] == 0){
            	//printf("Opened dir %s\n\r",path);
               break; //       
 	 	 	 	 	  //  
            }
            //printf("Readed dir %s/%s\n\r",path,fno.fname);
            if (fno.fname[0] == '.')
               continue; //   ''
#if _USE_LFN
            fn = *fno.lfname ? fno.lfname : fno.fname;
#else
            fn = fno.fname;
#endif
            if ((fno.fattrib & AM_DIR) && i>1)
            {   //  
            	//if(i<2){
            	//	sprintf(&path[i], "%s", fn);
            	//}else{
            		sprintf(&path[i], "/%s", fn);
            	//}
            	//printf("of dir %s\n\r", path);
                res = scan_files(path);
                if (res != FR_OK) break;
                //path[i] = 0;
            }
            else
            {   //  .
                printf("%s/%s - %d \n\r", path, fn, fno.fattrib & AM_DIR);
            }
        }
    }
    //printf("end scan dir %s\n\r", path);
    return res;
}

int main(void)
{
	RCC_ClocksTypeDef RCC_Clocks;

	SystemInit();
	initAll();



	  /* SysTick end of count event each 10ms */
    RCC_GetClocksFreq(&RCC_Clocks);
	SysTick_Config(RCC_Clocks.HCLK_Frequency / 100);
	//SysTick_Config(SystemCoreClock / 1000);

	printf("Started USART! RCC_Clocks.HCLK_Frequency=%d\n\r",RCC_Clocks.HCLK_Frequency);

	//char path[256];
	FRESULT st;
	FATFS fs;

	st=disk_initialize ( 0 );
	if ( st == 0 ){
		printf("SD inited!\n\r");

	}else{
		printf("Err SD Init! err=%d\n\r",st);
	}


	st=f_mount(0, &fs);
	if(st==FR_OK){
		printf("Mount disk!\n\r");
	}else{
		printf("err Mount disk! err=%d\n\r",st);
	}

	sprintf(&path, "/");

    /* USB configuration */
    USBConfig();
   // SysTick_Config(SystemCoreClock / 1000);

	uint i=0;
	while(1){

		if(UsartTestData()){
			uint8_t tmp=UsartGetData();
			printf("%c",tmp);
			if (tmp==13){
				st=scan_files((char *)&path);
				if(st==FR_OK){
					printf("Readed disk!\n\r");
				}else{
					printf("err Read disk! err=%d\n\r",st);
					printf("lastPath=%s\n\r",path);
				}
				i=0;
			}else if (tmp!=10){
				sprintf(&path[i++], "%c", tmp);

			}



		}

     /*
       // Disconnect the USB device
	    DCD_DevDisconnect(&USB_OTG_dev);
	    USB_OTG_StopDevice(&USB_OTG_dev);*/

	}
}



//  
void USART3_IRQHandler()
{
	if (USART_GetITStatus(USART3, USART_IT_TC) != RESET)
	{

	    //   
		USART_ClearITPendingBit(USART3, USART_IT_TC);
	   	UsartTx();
	}

	if(USART_GetITStatus(USART3, USART_IT_RXNE)!=RESET)
	{
    	UsartRx();
    }

}

/**
  * @brief  Initializes the USB for the demonstration application.
  * @param  None
  * @retval None
  */
static uint32_t USBConfig(void)
{
  USBD_Init(&USB_OTG_dev,
            USB_OTG_FS_CORE_ID,
            &USR_desc,
            &USBD_HID_cb,
            &USR_cb);

  return 0;
}
void Delay(__IO uint32_t nTime)
{
  TimingDelay = nTime;

  while(TimingDelay != 0);
}

